library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity a4_ss17_division_bench is
end a4_ss17_division_bench;

architecture Behavioral of a4_ss17_division_bench is

component a4_ss17_division Port(
	clk : in std_logic;
	a : in std_logic_vector(7 downto 0);
	b : in std_logic_vector(3 downto 0);
	q : out std_logic_vector(7 downto 0);
	start: in std_logic;
	busy : out std_logic);
end component;

signal clk: std_logic:='0';
signal start: std_logic:='0';
signal busy: std_logic:='0';
signal a: std_logic_vector(7 downto 0):=(others => '0');
signal b: std_logic_vector(3 downto 0):=(others => '0');
signal q: std_logic_vector(7 downto 0):=(others => '0');

signal rauschen: std_logic_vector(31 downto 0):=(others => '0');
	
begin

uut: a4_ss17_division Port map(
	clk => clk,
	a => a,
	b => b,
	q => q,
	start => start,
	busy => busy);


process begin
	wait for 10 ns;
	rauschen(31 downto 1) <= rauschen(30 downto 0) ;
	rauschen(0) <= not(rauschen(31) xor rauschen(22) xor rauschen(2) xor rauschen(1));
end process;

clk <= not clk after 5 ns;

process begin
	wait until rising_edge(clk);
	start <= '0';
	
	if busy = '0' and rauschen(0) = '1' then
		a <= rauschen(31 downto 24);
		if rauschen(23 downto 20) /= "0000" then
			b <= rauschen(23 downto 20);
		else
			b <= "0001";
		end if;
		start <= '1';
	end if;
end process;

end Behavioral;