library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity a4_ss17_division is Port(
	clk : in std_logic;
	a : in std_logic_vector(7 downto 0);
	b : in std_logic_vector(3 downto 0);
	q : out std_logic_vector(7 downto 0);
	start: in std_logic;
	busy : out std_logic);
end a4_ss17_division;

architecture Behavioral of a4_ss17_division is

-- Signale hierher!

begin

-- Beschreibung:
-- Es soll dividiert werden. Die Eingänge sind Takt, a (Dividend), b (Divisor), q (Quotient) und start und busy.
-- Es gibt zwei unterschiedliche Varianten:
-- 1. Nacheinander in mehreren Takten mit Handshake. Dabei wird das Signal busy auf '1' gelegt sobald gerechnet wird.
-- busy muss dazu kombinatorisch ungetaktet erzeugt werden.
-- start gibt an wenn neue Werte a und b vorliegen, die Rechnung wird in beliebig vielen Takten durchgeführt,
-- und das Ergebnis wird auf q gelegt und gleichzeitig busy auf '0' gesetzt.
-- 2. Ohne Handshake mit einer Pipeline. Dafür wird busy dauerhaft auf '0' gelegt und start kann ignoriert werden.
-- Es wird jetzt davon ausgegangen, dass mit jedem Takt neue Werte a und b angelegt werden.
-- Diese durchlaufen eine Rechenpipeline und nach einer festen Anzahl von Takten wird das jeweilige Ergebnis
-- auf den Aufgang q gelegt.
-- Die Testbench stellt sicher, dass b nie Null ist.
-- Diese Aufgabe soll wie die schriftliche Division, also durch Vergleiche und Subtraktionen gelöst werden.
-- Abzugeben ist wie immer nur die entsprechende VHDL Datei. Für die beiden Lösungsvarianten könnt ihr also
-- diese Datei kopieren oder auch beide Varianten in eine Datei schreiben und jeweils eine auskommentieren.
-- Viel Erfolg!

process begin
	wait until rising_edge(clk);

end process;

end Behavioral;